/*
 * sort.cpp
 *
 *  Created on: Dec 16, 2008
 *      Author: fritz
 */

#include <cstdlib>
#include <fstream>
#include <cstring>
#include <cmath>

#include "helpers.h"

using std::ifstream;

//Philipp: Added (taken from Match_CUDA_Functions.cu)
bool compare_str(ids_str first, ids_str second) {
	return (first.position < second.position);
}

void insert_sort(Matches &matches, Reference & ref, int scaffpos, int scaff_id, float score, bool forward, int tresh, bool rev) {

	int position = scaffpos + ref.get_scaff_pos(scaff_id);
	int shift = (int)round((double) tresh / 2.0);

	for (vector<Match>::iterator i = matches.match.begin(); i != matches.match.end(); i++) {
		if (abs(position - (*i).position) <= shift && (*i).forward == forward && (*i).BS_rev == rev && (*i).scaffID == scaff_id) {
			return;
		}
		if ((*i).score < score) {

			Match match;
			match.position = scaffpos + ref.get_scaff_pos(scaff_id); //scaffold pos
			match.score = score; // score
			match.forward = forward;
			match.scaffID = scaff_id;
			match.BS_rev = rev;
			matches.match.insert(i, match);
			matches.match.pop_back();
			return;
		}
	}

}

void insert_equal_scoring(Matches &matches, Reference & ref, int scaffpos, int scaff_id, float score, bool forward, int tresh, bool rev) {

	int position = scaffpos + ref.get_scaff_pos(scaff_id);
	int shift = (int)round((double) tresh / 2.0);

	for (vector<Match>::iterator i = matches.match.begin(); i != matches.match.end(); i++) {
		if (abs(position - (*i).position) <= shift && (*i).forward == forward && (*i).BS_rev == rev && (*i).scaffID == scaff_id) {
			return;
		}
	}

	Match match;
	match.position = position; //scaffold pos
	match.score = score; // score
	match.forward = forward;
	match.scaffID = scaff_id;
	match.BS_rev = rev;
	matches.match.push_back(match);
	//cout << "Position: " << match.position << " Score: " << match.score << " Direction: " << match.forward << endl;
}

void store(Matches &matches, Reference &ref, int scaffpos, int scaff_id, float score, bool forward, bool rev) {

	if (matches.match.size() > 1) {
		matches.match.erase((matches.match.begin() + 1), matches.match.end());
	}
	matches.match[0].position = scaffpos + ref.get_scaff_pos(scaff_id); //scaffold pos
	matches.match[0].score = score; // score
	matches.match[0].scaffID = scaff_id;
	matches.match[0].forward = forward;
	matches.match[0].BS_rev = rev;//ref.get_direction();
	Match match = matches.match[0];
	//cout << "Position: " << match.position << " Score: " << match.score << " Direction: " << match.forward << endl;
}

bool is_in(int *positions, int num, int size) {
	for (int i = 0; i < size; i++) {
		if (positions[i] == num) {
			return true;
		}
	}
	return false;
}

void select_random_position(Matches & match, int size) {

	int num = 0;
	int i = 0;
	int * positions = new int[size];

	memset(positions, -1, size * sizeof(int));

	while (i < size) {
		num = rand() % match.match.size();
		if (!is_in(positions, num, i)) {
			positions[i] = num;
			i++;
		}
	}

	for (size_t i = 0; i < match.match.size(); i++) {
		if (!is_in(positions, i, size)) {
			match.match.erase(match.match.begin() + i);
		}
	}
}

bool allwoed(size_t id) {

	string file = "/tmp/.NextGen";
	for (size_t j = 0; j < id; j++) {
		file += '1';
	}
	ifstream myfile;

	myfile.open(file.c_str(), ifstream::in);

	if (!myfile.good() || myfile.fail()) {
		FILE *file2;
		file2 = fopen(file.c_str(), "w");
		fclose(file2);
		return true;
	}

	return false;
}
