/*
 * CUDA_CPU.cuh
 *
 *  Created on: Nov 12, 2009
 *      Author: fritz
 */

#ifndef CUDA_CPU_CUH_
#define CUDA_CPU_CUH_

#include "helper/helpers.h"
#include "data/structs.h"
#include "data/reads.h"
#include "data/reference.h"

#include <vector>
#include <map>
#include <list>

using std::map;
using std::vector;
using std::pair;
using std::map;
using std::list;

//void hashScaffold(char * scaffold,parameters_str parameters,vector< vector<int> > & lookup_scaff,int mapsize,int mps);


void Sw(Reference & scaffold, Reads & reads, Parameters parameters,bool rev,vector< vector< int > > BSlookup);
//void MatchMismatch(bool ref_forward, bool forward,class_reference &  scaffold,
//		class_reads & reads,parameters_str parameters);
void Sw_double(Reference & scaffold, Reads & reads, Parameters parameters, bool rev,vector< vector< vector< Match > > > &candidates);




void CalcOutput3(vector<string> scaffold_file, Reads &reads, Parameters parameters);
void CalcPairs_BS(vector<string> scaffold_file, Reads & pairs, Parameters parameters, Reads reads);
void CalcPairs(vector<string> scaffold_file, Reads & pairs, Parameters parameters, Reads reads);
void Sw_optimal(Reference &  scaffold,Reads & reads,Parameters parameters,bool rev);

int call_parameter(int seqlengt);



void pre_filter_SW_pair_rest_BS(long & t1,list< pair<int, int> >  & liste,iterators_pair_str iter, vector<HelpStruct_pair> & helper1,char * & reads_cpu, char * & scaff_cpu, Reference & scaffold,Parameters parameters, bool * & bs_cpu);

int pre_filter_SW_BS(map<int, list<ids_str> > &liste, iterators_str & iter,	char * & reads_cpu, char * & scaff_cpu, vector<HelpStruct> & helper1,Reference & scaffold, Parameters parameters, bool & finished, vector< vector <int > > bslookup);
void pre_filter_SW_pair(long & t1, list<pair <int, int> > & liste,iterators_pair_str iter, vector<HelpStruct_pair> & helper1,char * & reads_cpu, char * & scaff_cpu, Reference & scaffold,Parameters parameters,vector< vector< int > > bslookup,bool *&bs_cpu);
int pre_filter_SW(map<int, list<ids_str> > &liste, iterators_str & iter, char * & reads_cpu, char * & scaff_cpu, vector<HelpStruct> & helper1, Reference & scaffold, Parameters parameters, bool & finished);
void post_proc_SW(float * results_cpu, Reads & reads,Reference & ref, float *& results_gpu, Parameters parameters,int & t2,long mem_result,vector<HelpStruct>  helper2,bool rev);
void pre_filter_SW_pair(long & t1, list< pair<int, int> >  & liste, iterators_pair_str iter, vector<HelpStruct_pair> & helper1, char * & reads_cpu, char * & scaff_cpu, Reference & scaffold, Parameters parameters);
void pre_filter_SW_pair_rest(long & t1,  list< pair<int, int> >  & liste, iterators_pair_str iter, vector<HelpStruct_pair> & helper1, char * & reads_cpu, char * & scaff_cpu, Reference & scaffold, Parameters parameters);
void post_proc_pair(vector<HelpStruct_pair> & helper1, Reads &pairs, long & t1, float * results_cpu, float * results_gpu, long mem_result, Reads reads, Reference & scaffold,size_t tresh);
size_t pre_filter_SW_optimal(Reads reads,char *&reads_cpu,iterators_str & iter,vector<int> & helper);
void post_proc_SW_optimal(float * score_gpu, float *& score_cpu,int * position_gpu, int *& position_cpu,Reads & reads,		Reference & ref,size_t & t1,long mem_score, long mem_position,size_t scaff_id,vector<int> & helper,iterators_str iter,bool rev);

void post_proc_Double(float * results_cpu,Reference & ref, float *& results_gpu, Parameters parameters,int & t2,long mem_result,vector<HelpStruct>  helper2,bool rev,vector< vector< vector< Match > > > & candidates,bool direction);

#endif /* CUDA_CPU_CUH_ */
