/*
 * SW_CUDA_Kernel.cu
 *
 *  Created on: Nov 12, 2009
 *      Author: fritz
 */

#include "cuda_sw_gpu.cuh"

__global__ void SW_Cuda2(char * scaffold_gpu,char *reads_gpu,float *matrix_gpu,float *results_gpu,float * param){

	unsigned int blockx = blockIdx.x*blockDim.x + threadIdx.x;
	unsigned int blocky = blockIdx.y*blockDim.y + threadIdx.y;
	unsigned int index = blockx + blocky *blockDim.x;

	extern __shared__ char smemf[];

	float * up = 		(float*)&smemf[0];
	float * curr_max = 	(float*)&smemf[sizeof(float)*256];
	unsigned int * z =				(unsigned int*)&smemf[2*sizeof(float)*256];
	char * read_character_shared = 	(char*)&smemf[(sizeof(unsigned int)+2*sizeof(float))*256];


	if(reads_gpu[index*(int)param[0]] != ' '){

		curr_max[threadIdx.x]=-2.0f;
		float score_shared =0.0f;
		float diag=0.0f;

		float * matrix_pos = &matrix_gpu[index*(int)(param[5]*2.0f)];
		float * post=matrix_pos;
		float * curr=&matrix_pos[(int)((param[5]))];

		__syncthreads();
		for(unsigned int run1=0; run1< param[0];run1++){

			read_character_shared[threadIdx.x] =reads_gpu[run1+index*(int)(param[0])];
			score_shared =0.0f;// up == last value.

			__syncthreads();
			unsigned int run2=run1;
			for(z[threadIdx.x]=0 ;z[threadIdx.x]<param[5];z[threadIdx.x]++){ //scaffold (int)param[5]

				if(run2<param[1]){ //smaller length, should not happen but annyway.
					if(run1>0 && z[threadIdx.x]< param[5]-1.0){
						up[threadIdx.x] = post[(z[threadIdx.x]+1)];
					}else{
						up[threadIdx.x] =0.0f;
					}

					__syncthreads();
					if(run1>0){
						//diag
						diag = post[z[threadIdx.x]];
					}else{
						diag =0.0f;
					}

//					 ================== calc ==============
					__syncthreads();
					if(read_character_shared[threadIdx.x] == scaffold_gpu[run2+index*(int)param[1]]){
						//match
						diag = diag+param[2];//*quality_val_shared[threadIdx.x] );
					}else if(read_character_shared[threadIdx.x] != 'N' && read_character_shared[threadIdx.x] != '#'){//78.0f){
						//missmatch
						diag = diag+param[3];//*quality_val_shared[threadIdx.x] );
					}

					score_shared =max(max(diag,0.0f),max((up[threadIdx.x]+param[4]),(score_shared+param[6]))); //local alignment!

					if(score_shared > curr_max[threadIdx.x]){
						curr_max[threadIdx.x] = score_shared;
					}
					run2++;
					__syncthreads();
					curr[z[threadIdx.x]] = score_shared;
				}

			}
			matrix_pos=curr;
			curr=post;
			post=matrix_pos;

		}
		__syncthreads();
		results_gpu[index]=curr_max[threadIdx.x];
	}else{
		results_gpu[index]=-1;
	}
}



__global__ void SW_Cuda_Back2(char * scaffold_gpu,char * reads_gpu,float *matrix_gpu,char *result_gpu,
		float * parameters,int * pos_gpu,float * matches_gpu,float * param){


	unsigned int blockx = blockIdx.x*blockDim.x + threadIdx.x;
	unsigned int blocky = blockIdx.y*blockDim.y + threadIdx.y;
	unsigned int index = blockx + blocky *blockDim.x;

// ============= shared mem ============================
	extern __shared__ char smemf[];


	float * up = 		(float*)&smemf[0];
	unsigned int * startposx = 	(unsigned int*)&smemf[sizeof(float)*256];
	unsigned int * pos_scaff = 	(unsigned int*)&smemf[(sizeof(unsigned int)+sizeof(float))*256];


	if(reads_gpu[index*(int)param[0]] != ' '){

		char read_character_shared;
		startposx[threadIdx.x]=0;
		float score_shared =0.0f;
		unsigned int run1=0;
		unsigned int z=0;
		float diag=0.0f;

		float * matrix_pos = &matrix_gpu[index*(int)(param[0]*param[5])];

		float curr_max=-2.0f;
		unsigned int startposy=0;

		for(run1=0; run1< (unsigned int)param[0];run1++){ //run1  == seqlength;

			read_character_shared =reads_gpu[run1+index*(int)(param[0])];
			score_shared =0.0f;// left == letzter Wert.

			__syncthreads();
			unsigned int run2=run1;//table_gpu[index*2];

			for(z=0;z<param[5]&&run2<param[1];z++){ //scaffold (int)param[5]

//				if(run2<param[1]){ //smaller length

					if(run1>0 && z+1< param[5]){
						up[threadIdx.x] = matrix_pos[(z+1) + (run1-1) *(int)param[5]];//   run1-1+((z+1)*(int)param[0])];
					}else{
						up[threadIdx.x] =0.0f;
					}

					if(run1>0){
						//diag
						diag = matrix_pos[z+(run1-1) *(int)param[5]];
					}else{
						diag=0.0f;
					}

//					 ================== calc ==============
					__syncthreads();

					if(read_character_shared == scaffold_gpu[run2+index*(int)param[1]]){
						//match
						diag += param[2];
					}else if(read_character_shared != 'N' && read_character_shared !='#' ){
						//missmatch
						diag += param[3];
					}

					score_shared =max(max(diag,0.0f),max((up[threadIdx.x]+param[4]),(score_shared+param[6]))); //local alignment!

					if(score_shared > curr_max){
						curr_max = score_shared;
						startposx[threadIdx.x] = run1;
						startposy = z;
//						pos_gpu[1+index*2]=(int)curr_max;
					}

					//vielleicht lagerst du das mal aus und kopierst dann 3/2 Zeilen auf einmal in den globalen mem
					matrix_pos[z+run1*(int)param[5]] = score_shared;
//				}
				run2++;
				__syncthreads();
			}
		}

		if(curr_max>0.0f){
			run1=startposx[threadIdx.x];
			z=startposy;
			startposx[threadIdx.x]=(int)param[1]-1;
			startposy=0;
			pos_scaff[threadIdx.x]=run1+z;

			while( z<(int)param[5] && run1<(int)param[0]){

				float score = matrix_pos[z+run1*(int)param[5]];

				if(run1>0 && z+1< param[5]){
					up[threadIdx.x] = matrix_pos[z+1 + (run1-1) *(int)param[5]];
				}else{
					up[threadIdx.x] =0.0f;
				}

				if(run1>0 ){
					//diag
					diag = matrix_pos[z+(run1-1)*(int)param[5]];
				}else{
					diag =0.0f;
				}

				if(z>0){
					//left
					score_shared =matrix_pos[(z-1)+run1*(int)param[5]];
				}else{
					score_shared =0.0f;
				}

				if(score==up[threadIdx.x]+param[4] && score !=diag+param[3] ){
					result_gpu[startposx[threadIdx.x]+index*(int)(param[1])*2]=reads_gpu[run1+index*(int)param[0]];
					result_gpu[startposx[threadIdx.x]+index*(int)(param[1])*2+(int)(param[1])]='-';

					run1--;
					z++;
				}else if(score==score_shared+param[6] && score !=diag+param[3]){
					result_gpu[startposx[threadIdx.x]+index*(int)(param[1])*2]='-';
					result_gpu[startposx[threadIdx.x]+index*(int)(param[1])*2+(int)(param[1])]=scaffold_gpu[pos_scaff[threadIdx.x]+index*(int)param[1]];

					pos_scaff[threadIdx.x]--;
					z--;
				}else if(score>0 && (score==diag||score==diag+param[3]||score==diag+param[2])){//diag (match or mismatch
					result_gpu[startposx[threadIdx.x]+index*(int)(param[1])*2]=reads_gpu[run1+index*(int)(param[0])];
					result_gpu[startposx[threadIdx.x]+index*(int)(param[1])*2+(int)(param[1])]=scaffold_gpu[(int)pos_scaff[threadIdx.x]+index*(int)param[1]];

					if(reads_gpu[run1+index*(int)param[0]] !='#' && reads_gpu[run1+index*(int)param[0]] !='N' && reads_gpu[run1+index*(int)param[0]] == scaffold_gpu[pos_scaff[threadIdx.x]+index*(int)param[1]]){
						//calc number of matches! (Needed for later use of identity.
						startposy++;
					}

					pos_scaff[threadIdx.x]--;
					run1--;
				}else{
					break; //vielleicht mit flag besser wiel weniger branch!
				}
				startposx[threadIdx.x]--;
			}

			matches_gpu[index]=(float)startposy;
			pos_gpu[index*2]=(int)pos_scaff[threadIdx.x]+1;
			pos_gpu[1+index*2]=run1+1;
		}
	}
}






//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++ BS Mode: ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++.



__global__ void SW_CudaBS(char * scaffold_gpu,char *reads_gpu,float *matrix_gpu,float *results_gpu,float * param){
	unsigned int blockx = blockIdx.x*blockDim.x + threadIdx.x;
	unsigned int blocky = blockIdx.y*blockDim.y + threadIdx.y;
	unsigned int index = blockx + blocky *blockDim.x;

	extern __shared__ char smemf[];

	float * left = 		(float*)&smemf[0];
	float * curr_max = 	(float*)&smemf[sizeof(float)*256];
	unsigned int * z =				(unsigned int*)&smemf[2*sizeof(float)*256];
	char * read_character_shared = 	(char*)&smemf[(sizeof(unsigned int)+2*sizeof(float))*256];


	if(reads_gpu[index*(int)param[0]] != ' '){

		curr_max[threadIdx.x]=-5.0f;
		float score_shared =0.0f;
		float diag=0.0f;

		float * matrix_pos = &matrix_gpu[index*(int)(param[5]*2.0f)];

		float * post=matrix_pos;
		float * curr=&matrix_pos[(int)((param[5]))];

		__syncthreads();
		for(unsigned int run1=0; run1< param[0];run1++){


			read_character_shared[threadIdx.x] =reads_gpu[run1+index*(int)(param[0])];
			score_shared =0.0f;// up == last value.

			__syncthreads();
			unsigned int run2=run1;
			for(z[threadIdx.x]=0 ;z[threadIdx.x]<param[5];z[threadIdx.x]++){ //scaffold (int)param[5]
				if(run2<param[1]){//smaller length, should not happen but annyway.
					if(run1>0 && z[threadIdx.x]< param[5]-1.0){
						left[threadIdx.x] = post[(z[threadIdx.x]+1)];
					}else{
						left[threadIdx.x] =0.0f;
					}
					__syncthreads();
					if(run1>0){
						//diag
						diag = post[z[threadIdx.x]];
					}else{
						diag =0.0f;
					}

//					 ================== calc ==============
					__syncthreads();

					if(read_character_shared[threadIdx.x] == 'A' && scaffold_gpu[(int)run2+index*(int)param[1]]=='A'){
						//match T-T
						diag = diag+param[7];
						//read_character_shared == 78.0  == 'N'
					}else if(read_character_shared[threadIdx.x] == 'T' && scaffold_gpu[(int)run2+index*(int)param[1]]=='T'){
						//match T-T
						diag = diag+param[7];
						//read_character_shared == 78.0  == 'N'
					}else if( read_character_shared[threadIdx.x] == scaffold_gpu[(int)run2+index*(int)param[1]]){
						//match
						diag = diag+param[2];//*quality_val_shared[threadIdx.x] );
					}else if(read_character_shared[threadIdx.x] == 'T' && scaffold_gpu[(int)run2+index*(int)param[1]]=='C'){
						//mismatch T-C
						diag = diag+param[8];
					}else if (read_character_shared[threadIdx.x] !='#'&& read_character_shared[threadIdx.x] !='N' ){
						//missmatch
						diag = diag+param[3];//*quality_val_shared[threadIdx.x] );
					}

					score_shared =max(max(diag,0.0f),max((left[threadIdx.x]+param[6]),(score_shared+param[4]))); //local alignment!

					if(score_shared > curr_max[threadIdx.x]){
						curr_max[threadIdx.x] = score_shared;
					}
					run2++;
					__syncthreads();
					curr[z[threadIdx.x]] = score_shared;
				}
			}
			matrix_pos=curr;
			curr=post;
			post=matrix_pos;

		}
		__syncthreads();
		results_gpu[index]=curr_max[threadIdx.x];
	}else{
		results_gpu[index]=-1;
	}
}

__global__ void SW_CudaBS_AG(char * scaffold_gpu,char *reads_gpu,float *matrix_gpu,float *results_gpu,float * param){

	unsigned int blockx = blockIdx.x*blockDim.x + threadIdx.x;
	unsigned int blocky = blockIdx.y*blockDim.y + threadIdx.y;
	unsigned int index = blockx + blocky *blockDim.x;

	extern __shared__ char smemf[];

	float * up = 		(float*)&smemf[0];
	float * curr_max = 	(float*)&smemf[sizeof(float)*256];
	unsigned int * z =				(unsigned int*)&smemf[2*sizeof(float)*256];
	char * read_character_shared = 	(char*)&smemf[(sizeof(unsigned int)+2*sizeof(float))*256];


	if(reads_gpu[index*(int)param[0]] != ' '){

		curr_max[threadIdx.x]=-5.0f;
		float score_shared =0.0f;
		float diag=0.0f;

		float * matrix_pos = &matrix_gpu[index*(int)(param[5]*2.0f)];
		float * post=matrix_pos;
		float * curr=&matrix_pos[(int)((param[5]))];

		__syncthreads();
		for(unsigned int run1=0; run1< param[0];run1++){
			curr_max[threadIdx.x]=-2.5f;
			read_character_shared[threadIdx.x] =reads_gpu[run1+index*(int)(param[0])];
			score_shared =0.0f;// up == last value.

			__syncthreads();
			unsigned int run2=run1;
			for(z[threadIdx.x]=0 ;z[threadIdx.x]<param[5];z[threadIdx.x]++){ //scaffold (int)param[5]

				if(run2<param[1]){//&& run2>=0.0){ //smaller length, should not happen but annyway.
					if(run1>0 && z[threadIdx.x]< param[5]-1.0){
						up[threadIdx.x] = post[(z[threadIdx.x]+1)];
					}else{
						up[threadIdx.x] =0.0f;
					}

					__syncthreads();
					if(run1>0){
						//diag
						diag = post[z[threadIdx.x]];
					}else{
						diag =0.0f;
					}

//					 ================== calc ==============
					__syncthreads();


					if(read_character_shared[threadIdx.x] == 'A' && scaffold_gpu[(int)run2+index*(int)param[1]]=='A'){
						//match T-T
						diag = diag+param[7];
						//read_character_shared == 78.0  == 'N'
					}else if( read_character_shared[threadIdx.x] == scaffold_gpu[(int)run2+index*(int)param[1]]){
						//match
						diag = diag+param[2];//*quality_val_shared[threadIdx.x] );
					}else if(read_character_shared[threadIdx.x] == 'A' && scaffold_gpu[(int)run2+index*(int)param[1]]=='G'){
						//mismatch T-C
						diag = diag+param[8];
					}else if (read_character_shared[threadIdx.x] !='#'&& read_character_shared[threadIdx.x] !='N' ){
						//missmatch
						diag = diag+param[3];//*quality_val_shared[threadIdx.x] );
					}

					score_shared =max(max(diag,0.0f),max((up[threadIdx.x]+param[4]),(score_shared+param[6]))); //local alignment!

					if(score_shared > curr_max[threadIdx.x]){
						curr_max[threadIdx.x] = score_shared;
					}
					run2++;
					__syncthreads();
					curr[z[threadIdx.x]] = score_shared;
				}

			}
			matrix_pos=curr;
			curr=post;
			post=matrix_pos;

		}
		__syncthreads();
		results_gpu[index]=curr_max[threadIdx.x];
	}else{
		results_gpu[index]=-1;
	}
}




__global__ void SW_CudaBS_TC(char * scaffold_gpu,char *reads_gpu,float *matrix_gpu,float *results_gpu,float * param){

	unsigned int blockx = blockIdx.x*blockDim.x + threadIdx.x;
	unsigned int blocky = blockIdx.y*blockDim.y + threadIdx.y;
	unsigned int index = blockx + blocky *blockDim.x;

	extern __shared__ char smemf[];

	float * up = 		(float*)&smemf[0];
	float * curr_max = 	(float*)&smemf[sizeof(float)*256];
	unsigned int * z =				(unsigned int*)&smemf[2*sizeof(float)*256];
	char * read_character_shared = 	(char*)&smemf[(sizeof(unsigned int)+2*sizeof(float))*256];


	if(reads_gpu[index*(int)param[0]] != ' '){

		curr_max[threadIdx.x]=-5.0f;
		float score_shared =0.0f;
		float diag=0.0f;

		float * matrix_pos = &matrix_gpu[index*(int)(param[5]*2.0f)];
		float * post=matrix_pos;
		float * curr=&matrix_pos[(int)((param[5]))];

		__syncthreads();
		for(unsigned int run1=0; run1< param[0];run1++){

			read_character_shared[threadIdx.x] =reads_gpu[run1+index*(int)(param[0])];
			score_shared =0.0f;// up == last value.

			__syncthreads();
			unsigned int run2=run1;
			for(z[threadIdx.x]=0 ;z[threadIdx.x]< param[5];z[threadIdx.x]++){ //scaffold (int)param[5]

				if(run2<param[1]){//&& run2>=0.0){ //smaller length, should not happen but annyway.
					if(run1>0 && z[threadIdx.x]< param[5]-1.0){
						up[threadIdx.x] = post[(z[threadIdx.x]+1)];
					}else{
						up[threadIdx.x] =0.0f;
					}

					__syncthreads();
					if(run1>0){
						//diag
						diag = post[z[threadIdx.x]];
					}else{
						diag =0.0f;
					}

//					 ================== calc ==============
					__syncthreads();


					if(read_character_shared[threadIdx.x] == 'T' && scaffold_gpu[(int)run2+index*(int)param[1]]=='T'){
						//match T-T
						diag = diag+param[7];
						//read_character_shared == 78.0  == 'N'
					}else if(read_character_shared[threadIdx.x] == 'T' && scaffold_gpu[(int)run2+index*(int)param[1]]=='T'){
						//match T-T
						diag = diag+param[7];
						//read_character_shared == 78.0  == 'N'
					}else if( read_character_shared[threadIdx.x] == scaffold_gpu[(int)run2+index*(int)param[1]]){
						//match
						diag = diag+param[2];//*quality_val_shared[threadIdx.x] );
					}else if(read_character_shared[threadIdx.x] == 'T' && scaffold_gpu[(int)run2+index*(int)param[1]]=='C'){
						//mismatch T-C
						diag = diag+param[8];
					}else if (read_character_shared[threadIdx.x] !='#'&& read_character_shared[threadIdx.x] !='N' ){
						//missmatch
						diag = diag+param[3];//*quality_val_shared[threadIdx.x] );
					}

					score_shared =max(max(diag,0.0f),max((up[threadIdx.x]+param[4]),(score_shared+param[6]))); //local alignment!

					if(score_shared > curr_max[threadIdx.x]){
						curr_max[threadIdx.x] = score_shared;
					}
					run2++;
					__syncthreads();
					curr[z[threadIdx.x]] = score_shared;
				}

			}
			matrix_pos=curr;
			curr=post;
			post=matrix_pos;

		}
		__syncthreads();
		results_gpu[index]=curr_max[threadIdx.x];
	}else{
		results_gpu[index]=-1;
	}
}

__global__ void SW_CudaBS_Pair(char * scaffold_gpu,char *reads_gpu,float *matrix_gpu,float *results_gpu,float * param,bool *bs_gpu){

	unsigned int blockx = blockIdx.x*blockDim.x + threadIdx.x;
	unsigned int blocky = blockIdx.y*blockDim.y + threadIdx.y;
	unsigned int index = blockx + blocky *blockDim.x;

	extern __shared__ char smemf[];

	float * up = 		(float*)&smemf[0];
	float * curr_max = 	(float*)&smemf[sizeof(float)*256];
	unsigned int * z =				(unsigned int*)&smemf[2*sizeof(float)*256];
	char * read_character_shared = 	(char*)&smemf[(sizeof(unsigned int)+2*sizeof(float))*256];


	if(reads_gpu[index*(int)param[0]] != ' '){

		char comp_read;
		char comp_scaff;
		if(!bs_gpu[index]){
			comp_read='T';
			comp_scaff='C';
			//T-C
		}else {
			comp_read='A';
			comp_scaff='G';
			//A-G
		}

		curr_max[threadIdx.x]=-5.0f;
		float score_shared =0.0f;
		float diag=0.0f;

		float * matrix_pos = &matrix_gpu[index*(int)(param[5]*2.0f)];
		float * post=matrix_pos;
		float * curr=&matrix_pos[(int)((param[5]))];

		__syncthreads();
		for(unsigned int run1=0; run1< param[0];run1++){
			curr_max[threadIdx.x]=-2.5f;
			read_character_shared[threadIdx.x] =reads_gpu[run1+index*(int)(param[0])];
			score_shared =0.0f;// up == last value.

			__syncthreads();
			unsigned int run2=run1;
			for(z[threadIdx.x]=0 ;z[threadIdx.x]<param[5];z[threadIdx.x]++){ //scaffold (int)param[5]

				if(run2<param[1]){//&& run2>=0.0){ //smaller length, should not happen but annyway.
					if(run1>0 && z[threadIdx.x]< param[5]-1.0){
						up[threadIdx.x] = post[(z[threadIdx.x]+1)];
					}else{
						up[threadIdx.x] =0.0f;
					}

					__syncthreads();
					if(run1>0){
						//diag
						diag = post[z[threadIdx.x]];
					}else{
						diag =0.0f;
					}

//					 ================== calc ==============
					__syncthreads();


					if(read_character_shared[threadIdx.x] == comp_read && scaffold_gpu[(int)run2+index*(int)param[1]]==comp_read){
						//match T-T
						diag = diag+param[7];
						//read_character_shared == 78.0  == 'N'
					}else if( read_character_shared[threadIdx.x] == scaffold_gpu[(int)run2+index*(int)param[1]]){
						//match
						diag = diag+param[2];//*quality_val_shared[threadIdx.x] );
					}else if(read_character_shared[threadIdx.x] == comp_read && scaffold_gpu[(int)run2+index*(int)param[1]]==comp_scaff){
						//mismatch T-C
						diag = diag+param[8];
					}else if (read_character_shared[threadIdx.x] !='#'&& read_character_shared[threadIdx.x] !='N' ){
						//missmatch
						diag = diag+param[3];//*quality_val_shared[threadIdx.x] );
					}

					score_shared =max(max(diag,0.0f),max((up[threadIdx.x]+param[4]),(score_shared+param[6]))); //local alignment!

					if(score_shared > curr_max[threadIdx.x]){
						curr_max[threadIdx.x] = score_shared;
					}
					run2++;
					__syncthreads();
					curr[z[threadIdx.x]] = score_shared;
				}

			}
			matrix_pos=curr;
			curr=post;
			post=matrix_pos;

		}
		__syncthreads();
		results_gpu[index]=curr_max[threadIdx.x];
	}else{
		results_gpu[index]=-1;
	}
}


__global__ void SW_CudaBS_Back2(char * scaffold_gpu,char * reads_gpu,float *matrix_gpu,char *result_gpu,
		float * parameters,int * pos_gpu,float * matches_gpu,bool *rev_gpu,float * param){


	unsigned int blockx = blockIdx.x*blockDim.x + threadIdx.x;
	unsigned int blocky = blockIdx.y*blockDim.y + threadIdx.y;
	unsigned int index = blockx + blocky *blockDim.x;

// ============= shared mem ============================
	extern __shared__ char smemf[];


	float * up = 		(float*)&smemf[0];
	unsigned int * startposx = 	(unsigned int*)&smemf[sizeof(float)*256];
	unsigned int * pos_scaff = 	(unsigned int*)&smemf[(sizeof(unsigned int)+sizeof(float))*256];

	if(reads_gpu[index*(int)param[0]] != ' '){

		char comp_read;
		char comp_scaff;
		if(!rev_gpu[index]){
			comp_read='T';
			comp_scaff='C';
			//T-C
		}else {
			comp_read='A';
			comp_scaff='G';
			//A-G
		}
		char read_character_shared;
		startposx[threadIdx.x]=0;
		float score_shared =0.0f;
		unsigned int run1=0;
		unsigned int z=0;
		float diag=0.0f;

		float * matrix_pos = &matrix_gpu[index*(int)(param[0]*param[5])];

		float curr_max=-2.0f;
		unsigned int startposy=0;

		for(run1=0; run1< (unsigned int)param[0];run1++){ //run1  == seqlength;

			read_character_shared =reads_gpu[run1+index*(int)(param[0])];
			score_shared =0.0f;// left == letzter wert.

			__syncthreads();
			unsigned int run2=run1;//table_gpu[index*2];

			for(z=0;z<param[5]&&run2<param[1];z++){ //scaffold (int)param[5]

				if(run2<param[1]){ //smaller length

					if(run1>0 && z+1< param[5]){
						up[threadIdx.x] = matrix_pos[(z+1) + (run1-1) *(int)param[5]];//   run1-1+((z+1)*(int)param[0])];
					}else{
						up[threadIdx.x] =0.0f;
					}

					if(run1>0){
						//diag
						diag = matrix_pos[z+(run1-1) *(int)param[5]];
					}else{
						diag=0.0f;
					}

//					 ================== calc ==============
					__syncthreads();

					if(read_character_shared==comp_read && scaffold_gpu[(int)run2+index*(int)param[1]]==comp_read){
						//match T-T or A-A
						diag = diag+param[7];
					}else if(read_character_shared == (float)scaffold_gpu[(int)run2+index*(int)param[1]]){
						//match
						diag = diag+param[2];//*quality_val_shared[threadIdx.x] );
					}else if(read_character_shared ==comp_read && scaffold_gpu[(int)run2+index*(int)param[1]]==comp_scaff){
						//mismatch T-C or A-G
						diag = diag+param[8];
					}else if (read_character_shared !='N' && read_character_shared !='#' ){
						//missmatch
						diag = diag+param[3];//*quality_val_shared[threadIdx.x] );
					}

					score_shared =max(max(diag,0.0f),max((up[threadIdx.x]+param[4]),(score_shared+param[6]))); //local alignment!

					if(score_shared > curr_max){
						curr_max = score_shared;
						startposx[threadIdx.x] = run1;
						startposy = z;
//						pos_gpu[1+index*2]=(int)curr_max;
					}
					matrix_pos[z+run1*(int)param[5]] = score_shared;
				}
				run2++;
				__syncthreads();

			}
		}

		if(curr_max>0.0f){
//			pos_gpu[1+index*2]=(int)curr_max;
			run1=startposx[threadIdx.x];
			z=startposy;
			startposx[threadIdx.x]=(int)param[1]-1;
			startposy=0;
			pos_scaff[threadIdx.x]=run1+z;

			while( z<(int)param[5] && run1<(int)param[0]){

				float score = matrix_pos[z+run1*(int)param[5]];

				if(run1>0 && z+1< param[5]){
					up[threadIdx.x] = matrix_pos[z+1 + (run1-1) *(int)param[5]];
				}else{
					up[threadIdx.x] =0.0f;
				}

				if(run1>0 ){
					//diag
					diag = matrix_pos[z+(run1-1)*(int)param[5]];
				}else{
					diag =0.0f;
				}

				if(z>0){
					//left
					score_shared =matrix_pos[(z-1)+run1*(int)param[5]];
				}else{
					score_shared =0.0f;
				}

				if(score==up[threadIdx.x]+param[4] && score !=diag+param[3] ){
					result_gpu[startposx[threadIdx.x]+index*(int)(param[1])*2]=reads_gpu[run1+index*(int)param[0]];
					result_gpu[startposx[threadIdx.x]+index*(int)(param[1])*2+(int)(param[1])]='-';

					run1--;
					z++;
//
				}else if(score==score_shared+param[6] && score !=diag+param[3]){
					result_gpu[startposx[threadIdx.x]+index*(int)(param[1])*2]='-';
					result_gpu[startposx[threadIdx.x]+index*(int)(param[1])*2+(int)(param[1])]=scaffold_gpu[pos_scaff[threadIdx.x]+index*(int)param[1]];

					pos_scaff[threadIdx.x]--;
					z--;
//
				}else if(score>0 && (score==diag||score==diag+param[3]||score==diag+param[2] ||score==diag+param[7]||score==diag+param[8]) ){//diag (match or mismatch
					result_gpu[startposx[threadIdx.x]+index*(int)(param[1])*2]=reads_gpu[run1+index*(int)(param[0])];
					result_gpu[startposx[threadIdx.x]+index*(int)(param[1])*2+(int)(param[1])]=scaffold_gpu[(int)pos_scaff[threadIdx.x]+index*(int)param[1]];

					if(reads_gpu[run1+index*(int)param[0]] !='#' && reads_gpu[run1+index*(int)param[0]] !='N'
							&&(( reads_gpu[run1+index*(int)param[0]] == scaffold_gpu[pos_scaff[threadIdx.x]+index*(int)param[1]]) ||( reads_gpu[run1+index*(int)param[0]] == comp_read && scaffold_gpu[pos_scaff[threadIdx.x]+index*(int)param[1]] == comp_scaff)) ){
						startposy++;
					}

					pos_scaff[threadIdx.x]--;
					run1--;
				}else{
					break;
				}
				startposx[threadIdx.x]--;

			}

			matches_gpu[index]=(float)startposy;
			pos_gpu[index*2]=(int)pos_scaff[threadIdx.x]+1;
			pos_gpu[1+index*2]=run1+1;
		}
	}
}






//=============================================================================================
//=============================================================================================
//============================ OPTIMAL LOCAL ALIGNMENT ========================================
//=============================================================================================
//=============================================================================================
//=============================================================================================






__global__ void SW_Cuda_optimal(char * scaffold_gpu,char *reads_gpu,float *matrix_gpu,float *score_gpu,int*positions,float * param){

	//TODO:
	unsigned int blockx = blockIdx.x*blockDim.x + threadIdx.x;
	unsigned int blocky = blockIdx.y*blockDim.y + threadIdx.y;
	unsigned int index = blockx + blocky *blockDim.x;

	extern __shared__ char smemf[];

	float * left = 		(float*)&smemf[0];
	float * curr_max = 	(float*)&smemf[sizeof(float)*256];
	unsigned int * z =				(unsigned int*)&smemf[2*sizeof(float)*256];
	char * scaff_character_shared = 	(char*)&smemf[(sizeof(unsigned int)+2*sizeof(float))*256];

	if(reads_gpu[index*(int)param[0]] != ' '){

		curr_max[threadIdx.x]=-2.0f;
		float up =0.0f;
		float diag=0.0f;
		int curr_pos=-1;
		float * matrix_pos = &matrix_gpu[index*(int)(param[0]*2.0f)];
		float * post=matrix_pos;
		float * curr=&matrix_pos[(int)((param[0]))];


		__syncthreads();
		for(unsigned int run1=0; run1< param[1];run1++){ //param[1]

			scaff_character_shared[threadIdx.x]=scaffold_gpu[run1];
			up =0.0f;// up == last value.

			__syncthreads();

			for(z[threadIdx.x]=0 ;z[threadIdx.x]<param[0];z[threadIdx.x]++){ //param[0]
				if(run1>0){
					left[threadIdx.x] = post[z[threadIdx.x]];
				}else{
					left[threadIdx.x] =0.0f;
				}

				__syncthreads();

				if(run1>0 && z[threadIdx.x]>0){
					//diag
					diag = post[z[threadIdx.x]-1];
				}else{
					diag =0.0f;
				}

//					 ================== calc ==============
				__syncthreads();
				if(reads_gpu[z[threadIdx.x]+index*(int)(param[0])]==scaff_character_shared[threadIdx.x]){
					//match
					diag = diag+param[2];
				}else if(reads_gpu[z[threadIdx.x]+index*(int)(param[0])]!= 'N' && reads_gpu[z[threadIdx.x]+index*(int)(param[0])]!= '#'){//78.0f){
					//missmatch
					diag = diag+param[3];
				}

				up =max(max(diag,0.0f),max((left[threadIdx.x]+param[6]),(up+param[4]))); //local alignment!

				if(up > curr_max[threadIdx.x]){
					curr_max[threadIdx.x] = up;
					curr_pos= (int)run1;
				}

				__syncthreads();
				curr[z[threadIdx.x]] = up;

			}
			matrix_pos=curr;
			curr=post;
			post=matrix_pos;

		}

		__syncthreads();
		score_gpu[index]=curr_max[threadIdx.x];
		positions[index]=curr_pos;
	}else{
		score_gpu[index]=36;
		positions[index]=500;
	}
}










//=============================================================================================
//=============================================================================================
//============================ GLOBAL ALIGNMENT ===============================================
//=============================================================================================
//=============================================================================================
//=============================================================================================




__global__ void Global_Cuda2(char * scaffold_gpu,char *reads_gpu,float *matrix_gpu,float *results_gpu,float * param){

	unsigned int blockx = blockIdx.x*blockDim.x + threadIdx.x;
	unsigned int blocky = blockIdx.y*blockDim.y + threadIdx.y;
	unsigned int index = blockx + blocky *blockDim.x;

	extern __shared__ char smemf[];

	float * up = 		(float*)&smemf[0];
	float * left = 	(float*)&smemf[sizeof(float)*256];
	unsigned int * z =				(unsigned int*)&smemf[2*sizeof(float)*256];
	char * read_character_shared = 	(char*)&smemf[(sizeof(unsigned int)+2*sizeof(float))*256];


	if(reads_gpu[index*(int)param[0]] != ' '){

//		curr_max[threadIdx.x]=-2.0f;
//		float left =0.0f;
		float diag=0.0f;

		float * matrix_pos = &matrix_gpu[index*(int)(param[5]*2.0f)];
		float * post=matrix_pos;
		float * curr=&matrix_pos[(int)((param[5]))];

		__syncthreads();
		unsigned int run1=0;
		for(run1=0; run1< param[0];run1++){

			read_character_shared[threadIdx.x] =reads_gpu[run1+index*(int)(param[0])];
			left[threadIdx.x] =-9999999999.0f;// up == last value.

			__syncthreads();
			unsigned int run2=run1;
			for(z[threadIdx.x]=0 ;z[threadIdx.x]<param[5] && run2<param[1];z[threadIdx.x]++){ //scaffold (int)param[5]
				if(run1>0 && z[threadIdx.x]< param[5]-1.0){
						up[threadIdx.x] = post[(z[threadIdx.x]+1)];
					}else{
						up[threadIdx.x] =-9999999999.0f;
					}

					__syncthreads();
					if(run1>0){
						//diag
						diag = post[z[threadIdx.x]];
					}else{
						diag =0.0f; //THINK ABOUT!
					}

//					 ================== calc ==============
					__syncthreads();
					if(read_character_shared[threadIdx.x] == scaffold_gpu[run2+index*(int)param[1]]){
						//match
						diag = diag+param[2];//*quality_val_shared[threadIdx.x] );
					}else if(read_character_shared[threadIdx.x] != 'N' && read_character_shared[threadIdx.x] != '#'){//78.0f){
						//missmatch
						diag = diag+param[3];//*quality_val_shared[threadIdx.x] );
					}

					left[threadIdx.x] =max(diag,max((up[threadIdx.x]+param[4]),(left[threadIdx.x]+param[6]))); //local alignment!

					run2++;
					__syncthreads();
					curr[z[threadIdx.x]] = left[threadIdx.x];
//				}

			}
			matrix_pos=curr;
			curr=post;
			post=matrix_pos;

		}
		__syncthreads();
		run1= param[0];
		left[threadIdx.x]=-999999.0f;
		for(z[threadIdx.x]=0;z[threadIdx.x]<param[5];z[threadIdx.x]++){
			if(left[threadIdx.x]<post[z[threadIdx.x]]){
				left[threadIdx.x]=post[z[threadIdx.x]];
			}
		}
		results_gpu[index]=left[threadIdx.x];
	}else{
		results_gpu[index]=-1;
	}
}


__global__ void Global_Cuda_Back2(char * scaffold_gpu,char * reads_gpu,float *matrix_gpu,char *result_gpu,
		float * parameters,int * pos_gpu,float * matches_gpu,float * param){


	unsigned int blockx = blockIdx.x*blockDim.x + threadIdx.x;
	unsigned int blocky = blockIdx.y*blockDim.y + threadIdx.y;
	unsigned int index = blockx + blocky *blockDim.x;

// ============= shared mem ============================
	extern __shared__ char smemf[];


	float * up = 		(float*)&smemf[0];
	unsigned int * startposx = 	(unsigned int*)&smemf[sizeof(float)*256];
	unsigned int * pos_scaff = 	(unsigned int*)&smemf[(sizeof(unsigned int)+sizeof(float))*256];


	if(reads_gpu[index*(int)param[0]] != ' '){

		char read_character_shared;
		startposx[threadIdx.x]=0;
		float left =0.0f;
		int run1=0;
		int z=0;
		float diag=0.0f;
		int run2=0;
		float * matrix_pos = &matrix_gpu[index*(int)(param[0]*param[5])];


		unsigned int startposy=0;

		for(run1=0; run1< (unsigned int)param[0];run1++){ //run1  == seqlength;

			read_character_shared =reads_gpu[run1+index*(int)(param[0])];
			left =-99999999.0f;// left == letzter wert.

			__syncthreads();
			run2=run1;//table_gpu[index*2];

			for(z=0;z<param[5]&&run2<param[1];z++){ //scaffold (int)param[5]
				if(run1>0 && z+1< param[5]){
					up[threadIdx.x] = matrix_pos[(z+1) + (run1-1) *(int)param[5]];//   run1-1+((z+1)*(int)param[0])];
				}else{
					up[threadIdx.x] =-99999999.0f;
				}

				if(run1>0){
					//diag
					diag = matrix_pos[z+(run1-1) *(int)param[5]];
				}else{
					diag=0.0f;
				}

//					 ================== calc ==============
				__syncthreads();

				if(read_character_shared == scaffold_gpu[run2+index*(int)param[1]]){
					//match
					diag += param[2];
				}else if(read_character_shared != 'N' && read_character_shared !='#' ){
					//missmatch
					diag += param[3];
				}

				left =max(diag,max((up[threadIdx.x]+param[4]),(left+param[6])));

				matrix_pos[z+run1*(int)param[5]] = left;

				run2++;
				__syncthreads();

			}

		}
		run1=param[0]-1;
		left=-99999999.0f;
		for(z=0;z<param[5];z++){//+run1
			if(left<matrix_pos[z+run1*(int)param[5]] ){
				left=matrix_pos[z+run1*(int)param[5]];
				run2=z;
			}
		}
		left =-99999999.0f;
		z=run2;

		startposx[threadIdx.x]=(int)param[1]-1;
		startposy=0;
		pos_scaff[threadIdx.x]=run1+z;


		if(pos_scaff[threadIdx.x]>param[1]){
			pos_gpu[1+index*2]=-111;
			return;
		}

		if(z==param[5]){
			pos_gpu[1+index*2]=-666;
			return;
		}

		while( z<param[5] && run1>-1){// z<(int)param[5] ||  run1<(int)param[0]){

			float score = matrix_pos[z+run1*(int)param[5]];

			if(run1>0 && z+1< (int)param[5]){
				up[threadIdx.x] = matrix_pos[(z+1) + (run1-1) *(int)param[5]];
			}else{
				up[threadIdx.x] =-99999999.0f;
			}

			if(z>0){
				//left
				left =matrix_pos[(z-1)+run1*(int)param[5]];
			}else{
				left =-99999999.0f;
			}


			if(run1>0 ){
				//diag
				diag = matrix_pos[z+(run1-1) *(int)param[5]];
			}else{
				diag=0.0f;
			}


			if(score==up[threadIdx.x]+param[4] && (score !=diag+param[3]||score !=diag+param[2]) ){
				result_gpu[startposx[threadIdx.x]+index*(int)(param[1])*2]=reads_gpu[run1+index*(int)param[0]];
				result_gpu[startposx[threadIdx.x]+index*(int)(param[1])*2+(int)(param[1])]='-';

				run1--;
				z++;
			}else if(score==left+param[6] && (score !=diag+param[3]||score !=diag+param[2])){
				result_gpu[startposx[threadIdx.x]+index*(int)(param[1])*2]='-';
				result_gpu[startposx[threadIdx.x]+index*(int)(param[1])*2+(int)(param[1])]=scaffold_gpu[pos_scaff[threadIdx.x]+index*(int)param[1]];

				pos_scaff[threadIdx.x]--;
				z--;
			}else if(score==diag||score==diag+param[3]||score==diag+param[2]){//diag (match or mismatch//					result_gpu[startposx[threadIdx.x]+index*(int)(param[1])*2]=reads_gpu[run1+index*(int)(param[0])];

				result_gpu[startposx[threadIdx.x]+index*(int)(param[1])*2]=reads_gpu[run1+index*(int)param[0]];
				result_gpu[startposx[threadIdx.x]+index*(int)(param[1])*2+(int)(param[1])]=scaffold_gpu[(int)pos_scaff[threadIdx.x]+index*(int)param[1]];

				if(score!=diag && reads_gpu[run1+index*(int)param[0]] == scaffold_gpu[pos_scaff[threadIdx.x]+index*(int)param[1]]){
					startposy++;
				}

				pos_scaff[threadIdx.x]--;

				run1--;

			}else{
				break;
			}

			startposx[threadIdx.x]--;
		}

		matches_gpu[index]=(float)startposy;
		pos_gpu[index*2]=(int)pos_scaff[threadIdx.x]+1;
		pos_gpu[1+index*2]=run1+1;
	}
}




//=============================================================================================
//=============================================================================================
//============================ Double ALIGNMENT ===============================================
//=============================================================================================
//=============================================================================================
//=============================================================================================


__global__ void Score_Calc_Double (char * scaffold_gpu,char *reads_gpu,float *matrix_gpu,float *results_gpu,int *param,float * scores){
	unsigned int blockx = blockIdx.x*blockDim.x + threadIdx.x;
	unsigned int blocky = blockIdx.y*blockDim.y + threadIdx.y;
	unsigned int index = blockx + blocky *blockDim.x;

	extern __shared__ char smemf[];

	float * up = 		(float*)&smemf[0];
	float * curr_max = 	(float*)&smemf[sizeof(float)*256];
	unsigned int * z =				(unsigned int*)&smemf[2*sizeof(float)*256];
	char * read_character_shared = 	(char*)&smemf[(sizeof(unsigned int)+2*sizeof(float))*256];


	if(reads_gpu[index*param[0]] != ' '){

		curr_max[threadIdx.x]=-2.0f;
		float left =0.0f;
		float diag=0.0f;

		unsigned int run1=0;
		unsigned int run2=0;

		float * matrix_pos = &matrix_gpu[index*(param[2]*2)];
		float * post=matrix_pos;
		float * curr=&matrix_pos[param[2]];

		for(int turn=0;turn<param[3];turn++){

			__syncthreads();
			for(run1=0; run1< param[0];run1++){

				read_character_shared[threadIdx.x] =reads_gpu[run1+index*param[0]];
				left =0.0f;// left == last value.

				__syncthreads();
				run2=run1;
				for(z[threadIdx.x]=0 ;z[threadIdx.x]<param[2];z[threadIdx.x]++){ //scaffold (int)param[5]

					if(run2<param[1]){ //smaller length, should not happen but annyway.
						if(run1>0 && z[threadIdx.x]< param[2]-1){
							up[threadIdx.x] = post[(z[threadIdx.x]+1)];
						}else{
							up[threadIdx.x] =0.0f;
						}

						__syncthreads();
						if(run1>0){
							//diag
							diag = post[z[threadIdx.x]];
						}else{
							diag =0.0f;
						}

	//					 ================== calc ==============
						__syncthreads();
						if(read_character_shared[threadIdx.x] == scaffold_gpu[run2+index*param[1]]){
							//match
							diag = diag+scores[turn*4];//*quality_val_shared[threadIdx.x] );
						}else if(read_character_shared[threadIdx.x] != 'N' && read_character_shared[threadIdx.x] != '#'){//78.0f){
							//missmatch
							diag = diag+scores[1+turn*4];//*quality_val_shared[threadIdx.x] );
						}

						left =max(max(diag,0.0f),max((up[threadIdx.x]+scores[2+turn*4]),(left+scores[3+turn*4]))); //local alignment!

						if(left > curr_max[threadIdx.x]){
							curr_max[threadIdx.x] = left;
						}
						run2++;
						__syncthreads();
						curr[z[threadIdx.x]] = left;
					}

				}
				matrix_pos=curr;
				curr=post;
				post=matrix_pos;

			}
			__syncthreads();
			results_gpu[turn*2+param[3]*index*2]=curr_max[threadIdx.x];
			//end local alignment
			curr_max[threadIdx.x]=-2.0f;


			diag=0.0f;


			__syncthreads();
			 run1=0;
			for(run1=0; run1< param[0];run1++){

				read_character_shared[threadIdx.x] =reads_gpu[run1+index*param[0]];
				left =-9999999999.0f;// left == last value.

				__syncthreads();
				run2=run1;
				for(z[threadIdx.x]=0 ;z[threadIdx.x]<param[2] && run2<param[1];z[threadIdx.x]++){ //scaffold (int)param[5]
					if(run1>0 && z[threadIdx.x]< param[2]-1){
						up[threadIdx.x] = post[(z[threadIdx.x]+1)];
					}else{
						up[threadIdx.x] =-9999999999.0f;
					}

					__syncthreads();
					if(run1>0){
						//diag
						diag = post[z[threadIdx.x]];
					}else{
						diag =0.0f; //THINK ABOUT!
					}

//					 ================== calc ==============
					__syncthreads();
					if(read_character_shared[threadIdx.x] == scaffold_gpu[run2+index*param[1]]){
						//match
						diag = diag+scores[turn*4];//*quality_val_shared[threadIdx.x] );
					}else if(read_character_shared[threadIdx.x] != 'N' && read_character_shared[threadIdx.x] != '#'){//78.0f){
						//missmatch
						diag = diag+scores[1+turn*4];//*quality_val_shared[threadIdx.x] );
					}

					left =max(diag,max((up[threadIdx.x]+scores[2+turn*4]),(left+scores[3+turn*4]))); //local alignment!

					run2++;
					__syncthreads();
					curr[z[threadIdx.x]] = left;

				}
				matrix_pos=curr;
				curr=post;
				post=matrix_pos;

			}
			__syncthreads();
			run1= param[0];
			left=-999999.0f;
			for(z[threadIdx.x]=0;z[threadIdx.x]<param[2];z[threadIdx.x]++){
				if(left<post[z[threadIdx.x]]){
					left=post[z[threadIdx.x]];
				}
			}
			results_gpu[1+turn*2+param[3]*index*2]=left;
			//end semi global alignment
		}

	}else{
		results_gpu[param[3]*index*2]=-1;
		results_gpu[1+param[3]*index*2]=-1;
	}
}
