/*
 * Match_CUDA_Functions.cu
 *
 *  Created on: Dec 4, 2009
 *      Author: fritz
 */


#include <list>
#include <map>
using namespace std;

class is_near2
{
	int diff;

public:
	is_near2(){

	}
	bool operator() (ids_str &first, ids_str &second)
	{
		if(first.position==second.position){
			first.frequ++;
			return true;
		}
		return false;

	}
};


bool compare_str (ids_str first, ids_str second){
	  return (first.position<second.position);
}


bool compare_matches_str (ids_str first, ids_str second){
	  return (first.frequ<second.frequ);
}


int pre_filter_Match(map< int, list <ids_str > > &liste, iterators_str & iter,
		char * & reads_cpu,char * & scaff_cpu,
		vector<HelpStruct> & helper1,Reference & scaffold ,Parameters parameters,bool & finished){

	size_t t1=0;
	if(!finished){
		for( map< int, list <ids_str > >::iterator i=liste.begin();i!=liste.end();i++){
			(*i).second.sort(compare_str);
			(*i).second.unique(is_near2());

			for (list<ids_str>::iterator it=(*i).second.begin(); it!=(*i).second.end(); ++it){
				if((*it).frequ >= parameters.seedword_hits){
					memcpy(&reads_cpu[t1*iter.seqlength],(*iter.read_pos).c_str(),iter.seqlength*sizeof(char));
					int pos = (*it).position-iter.shift;
					if(pos>=0 && pos<scaffold.sequence[(*it).scaff_id-scaffold.get_ID()].size()){
						memcpy(&scaff_cpu[t1*iter.size],scaffold.sequence[(*it).scaff_id-scaffold.get_ID()].substr((size_t)pos,(size_t)iter.size).c_str(),iter.size*sizeof(char));
					}else{
						size_t z=0;
						for(int i=pos;i<pos;i++){
							if(i<0||i>=scaffold.sequence[(*it).scaff_id-scaffold.get_ID()].size()){
								scaff_cpu[z*t1]='N';
							}else{
								scaff_cpu[z*t1]=scaffold.sequence[(*it).scaff_id-scaffold.get_ID()][i];
							}
							z++;
						}
					}
					helper1[t1].id = iter.readID;
					helper1[t1].position =(*it).position;
					helper1[t1].scaff_id =(*it).scaff_id;
					t1++;
					if(t1==iter.proc){
						(*i).second.erase((*i).second.begin(),it);
						finished=false;
						return t1;
					}
				}
			}
			(*i).second.clear();
		}
		finished=true;
		liste.clear();
		iter.readID++;
		iter.mapps++;
		iter.match++;
		iter.read_pos++;
	}

	while(iter.readID<iter.numofSeq){
		if(parameters.equal_scoring || (*iter.match).match[parameters.X_best_hits-1].score < (*iter.match).orig_length*parameters.match){
			ids_str temp;
			temp.frequ=1;
			//collect positions
			for(vector<HashKey>::iterator i=(*iter.mapps).begin();i!=(*iter.mapps).end();i++){
				for(vector< pair<int,int> >::iterator j=scaffold.lookup_scaffold[(*i).key].begin();j!=scaffold.lookup_scaffold[(*i).key].end();j++){
					temp.position=(*j).first-(*i).pos;
					temp.scaff_id=(*j).second;
					liste[(*j).second].push_back(temp);
				}
			}

			for( map< int, list <ids_str > >::iterator j=liste.begin();j!=liste.end();j++){
				//filter and count frequencies:
				(*j).second.sort(compare_str);
				(*j).second.unique(is_near2());
				for (list<ids_str>::iterator it=(*j).second.begin(); it!=(*j).second.end(); ++it){
					if((*it).frequ >= parameters.seedword_hits){
						//sum up all positions passed criteria
						memcpy(&reads_cpu[t1*iter.seqlength],(*iter.read_pos).c_str(),iter.seqlength*sizeof(char));
						int pos = (*it).position-iter.shift;
						if(pos>=0 && pos<scaffold.sequence[(*it).scaff_id-scaffold.get_ID()].size()){
							memcpy(&scaff_cpu[t1*iter.size],scaffold.sequence[(*it).scaff_id-scaffold.get_ID()].substr((size_t)pos,(size_t)iter.size).c_str(),iter.size*sizeof(char));
						}else{
							size_t z=0;
							for(int i=pos;i<pos;i++){
								if(i<0||i>=scaffold.sequence[(*it).scaff_id-scaffold.get_ID()].size()){
									scaff_cpu[z*t1]='N';
								}else{
									scaff_cpu[z*t1]=scaffold.sequence[(*it).scaff_id-scaffold.get_ID()][i];
								}
								z++;
							}
						}
						helper1[t1].id = iter.readID;
						helper1[t1].position =(*it).position;
						helper1[t1].scaff_id =(*it).scaff_id;
						t1++;
						if(t1==iter.proc){
							(*j).second.erase((*j).second.begin(),it);
							finished=false;
							return t1;
						}
					}
				}
				(*j).second.clear();
			}
			liste.clear();
		}
		finished=true;
		iter.readID++;
		iter.mapps++;
		iter.match++;
		iter.read_pos++;
	}

	memset(&reads_cpu[t1*iter.seqlength],' ',(iter.proc-t1)*iter.seqlength*sizeof(char));
	return t1;
}


void post_proc_Match(float * results_cpu, Reads & reads,
		Reference & ref, float *& results_gpu, Parameters parameters,
		size_t & t2,long mem_result,vector<HelpStruct>  helper2){

	CUDA_SAFE_CALL(cudaMemcpy(results_cpu,results_gpu,mem_result*sizeof(float),cudaMemcpyDeviceToHost));

	for(size_t k=0;k< t2;k++){
		if(results_cpu[k]>=reads.matches[helper2[k].id].match[0].score){ //nbest
			if(results_cpu[k]>reads.matches[ helper2[k].id].match[0].score){
				store(reads.matches[ helper2[k].id],ref,helper2[k].position,helper2[k].scaff_id,results_cpu[k],reads.get_direction());
			}else {
				insert_equal_scoring(reads.matches[helper2[k].id],ref,helper2[k].position,helper2[k].scaff_id,results_cpu[k],reads.get_direction(),parameters.corridor_with);
			}
		}
	}
	t2=0;
}

